#version 410 core

uniform float fGlobalTime; // in seconds
uniform vec2 v2Resolution; // viewport resolution (in pixels)
uniform float fFrameTime; // duration of the last frame, in seconds

uniform sampler1D texFFT; // towards 0.0 is bass / lower freq, towards 1.0 is higher / treble freq
uniform sampler1D texFFTSmoothed; // this one has longer falloff and less harsh transients
uniform sampler1D texFFTIntegrated; // this is continually increasing
uniform sampler2D texPreviousFrame; // screenshot of the previous frame
uniform sampler2D texChecker;
uniform sampler2D texNoise;
uniform sampler2D texTex1;
uniform sampler2D texTex2;
uniform sampler2D texTex3;
uniform sampler2D texTex4;
uniform float midi01;
uniform float midi02;
uniform float midi03;
uniform float midi04;
uniform float midi05;
uniform float midi06;
uniform float midi07;
uniform float midi08;
uniform float midi09;
uniform float midi10;
uniform float midi11;
uniform float midi12;
uniform float midi13;
uniform float midi14;
uniform float midi15;
uniform float midi16;
uniform float midi17;
uniform float midi18;
uniform float midi19;
uniform float midi20;
uniform float midi21;
uniform float midi22;
uniform float midi23;
uniform float midi24;
uniform float midi25;
uniform float midi26;
uniform float midi27;
uniform float midi28;
uniform float midi29;
uniform float midi30;
uniform float midi31;
uniform float midi32;
uniform float midi33;
uniform float midi34;
uniform float midi35;
uniform float midi36;
uniform float midi37;
uniform float midi38;
uniform float midi39;
uniform float midi40;
uniform float midi41;
uniform float midi42;
uniform float midi43;
uniform float midi44;
uniform float midi45;
uniform float midi46;
uniform float midi47;
uniform float midi48;

layout(location = 0) out vec4 out_color; // out_color must be written in order to see anything

struct Matter {
  float m;
  float glow;
  float glow02;
};

struct Ray
{
  vec3 p;
  vec3 dir;
};


Matter mat;
Ray ray;
vec3 res;

mat2 rot(float a)
{
  float ca = cos(a);
  float sa = sin(a);
  
  return mat2(ca, sa, -sa, ca);
}

vec3 rand(vec3 p)
{
  return   fract(
  sin(
  vec3(dot(p, vec3(1.0, 57.0, 113.0)),
  dot(p, vec3(57.0, 1.0, 113.0)),
  dot(p, vec3(113.0, 57.0, 1.0)
  ))) * 45362.2356);
}

vec3 voronoi(vec3 x)
{
  vec3 p = floor(x);
  vec3 f= fract(x);
  
  float id = 0.0;
  vec2 res = vec2(100.0);
  for(int k = -1; k<=1;++k )
   for(int j = -1; j<=1;++j )
   for(int i = -1; i<=1;++i )
  {
    vec3 b=vec3(float(i), float(j), float(k));
    vec3 r = b-f+rand(p+b);
    float d = dot(r,r);
    
    if(d < res.x)
    {
      res.x = d;
    } else if(d<res.y)
    {
      res.y = d;
    }
  }
  
  return vec3(sqrt(res), id);
}

float sphere(vec3 p, float r)
{
  return length(p) - r;
}

float box(vec3 p, vec3 r)
{
  p=abs(p) - r;
  return max(p.x, max(p.y, p.z));
}


void map(inout Matter ma, vec3 p)
 {
   float mat01 = 10.0, mat02 = 10.0, mat03 = 10.0;
   vec3 p01 = p, p02 = p, p03 = abs(p+vec3(0.0, 1.0, 0.0));
   
   p01.xy *= rot(fGlobalTime + smoothstep(fract(fGlobalTime*0.75), 0.45, 0.65) * 2.0);
   p03.xy *= rot(fGlobalTime);
   
   p02.xy *= rot(fGlobalTime + p.y + p.z);
   
   float ff = texture(texFFTSmoothed, 0.05).x * 5.0;
   
   mat01 = sphere(p, 2.5+ff);
   if(mat01 < 0.01)
   {
     mat02 = sphere(p, 1.5 + ff * 2.0);
     
     vec3 v = voronoi(1.0*p01+p + smoothstep(fract(fGlobalTime), 0.45, 0.65));
     float f = clamp(1.0 * (v.y-v.x), 0.0, 1.0);
     
     mat02 = max(mat02, -sphere(p03+vec3(0.0, 1.0, 0.0), 2.0));
     
     mat03 = sphere(p02+vec3(-2.0 * fract(fGlobalTime*0.25)*50.0, 0.0, 0.0), 1.5);
     mat03 = max(mat03, -box(p02+vec3(1.5-2.0 * fract(fGlobalTime*0.25)*5.0, 0.0, 0.0), vec3(1.35)));
     mat03 = max(mat03, -box(p02-vec3(1.5+2.0 * fract(fGlobalTime*0.25)*5.0, 0.0, 0.0), vec3(1.35)));
     mat03 = max(mat03, -sphere(p02-2.0 * fract(fGlobalTime*0.25)*5.0, 1.45));
     
     
     mat02 += f+ff;
     
     
     ma.glow += 0.15/(0.05+abs(mat02));
   ma.glow02 += 0.15/(0.05+abs(mat03));
     
    ma.m = mat02;
     return;
   }
   
   
   
   //ma.glow += 0.15/(0.005+abs(mat01));
   
   ma.m = mat01;
   
 }

void main(void)
{
	vec2 uv = vec2(gl_FragCoord.x / v2Resolution.x, gl_FragCoord.y / v2Resolution.y);
	uv -= 0.5;
	uv /= vec2(v2Resolution.y / v2Resolution.x, 1);
  
  vec3 o = vec3(5.0, 0.0, 5.0), t = vec3(0.0);
  vec3 fr = normalize(t-o);
  vec3 ri = normalize(cross(vec3(0.0,1.0,0.0), fr));
  vec3 up = normalize(cross(ri, fr));
  ray.dir = normalize(fr + uv.x * ri + uv.y * up);
  ray.p = ray.dir * 0.25 + o;
  
  res = vec3(0.5);
  
  for(int i = 0; i< 200; ++i)
  {
    map(mat, ray.p);
    
    if(mat.m < 0.01)
    {
      mat.m = 10.0 * midi02;
    }
    
    res -= mat.glow * vec3(1.0) * 0.0001 * midi01;
    res += mat.glow02 * vec3(uv.x * 4.0, uv.y * 4.0, 1.0) * 0.0001 * midi03;
    
    ray.p += ray.dir * 0.25 * mat.m;
    
  }

	out_color = vec4(res, 1.0);
}